// THIS SCRIPT, WAS MADE BY Ahead#0034.

//-------------------------------------
//# Anti-Ana
//#
//# "A mommy a day keeps Ana away!"
//-------------------------------------

if(isPackage(AntiAna)) //did the package somehow exist before we created it?
	deactivatePackage(AntiAna); //if it did then deactivate it

if(trim($Pref::AntiAna::Enabled) $= "") { //is the pref value nothing?
	warn("Server_AntiAna | Invalid value for $Pref::AntiAna::Enabled, resetting pref"); //if it is, log it
	$Pref::AntiAna::Enabled = true; //and then reset it
}
if(trim($Pref::AntiAna::Debug) $= "") {
	warn("Server_AntiAna | Invalid value for $Pref::AntiAna::Debug, resetting pref");
	$Pref::AntiAna::Debug = false;
}
if(trim($Pref::Server::ScriptEval::ShowHostSilentEval) $= "") {
	warn("Server_AntiAna | Invalid value for $Pref::AntiAna::Reason, resetting pref");
	$Pref::AntiAna::Reason = "Automatically banned by Anti-Ana";
}

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs") || isFile("Add-Ons/System_BlocklandGlass/server.cs")) { //does rtb or glass exist?
	if(!$RTB::Hooks::ServerControl) //is there no rtb server control hook?
		exec("Add-Ons/System_ReturnToBlockland/hooks/ServerControl.cs"); //if there isn't, try to execute it
	if(!$AntiAna_StartedOnce) { //check if we've even ran the addon once
		RTB_registerPref("Enabled?", "AntiAna", "$Pref::AntiAna::Enabled", "bool", "Server_AntiAna", 1, 0, 1); //pref for checking if we want the package enabled
		RTB_registerPref("Debug", "AntiAna", "$Pref::AntiAna::Debug", "bool", "Server_AntiAna", 0, 0, 1); //pref for add-on logging in console
		RTB_registerPref("Reason", "AntiAna", "$Pref::AntiAna::Reason", "string 255", "Server_AntiAna", "Automatically banned by Anti-Ana", 0, 1); //pref for ban reason
		$AntiAna_StartedOnce = true; //set ran once variable so we don't trigger this again
	}
}

package AntiAna { //create the package
	function GameConnection::autoAdminCheck(%client) { //append this base function so we can run our actual code
		if($Pref::AntiAna::Debug) //is debug on?
			echo("Server_AntiAna | Checking client" SPC %client.getPlayerName() SPC "(" @ %client.bl_id @ ")..."); //if it is, log this
		if(%client.getPlayerName() $= "Ana") { //check if the client's name is Ana; todo: maybe implement an ip check? how many ips does ana even have
			BanBLID(%client.bl_id, -1, $Pref::AntiAna::Reason); //if it is, ban
			if($Pref::AntiAna::Debug)
				echo("Server_AntiAna | Client" SPC %client.name SPC "(" @ %client.bl_id @ ") not OK, banning!");
		} else { //if the client's name is not Ana, well...they're spared
			if($Pref::AntiAna::Debug)
				echo("Server_AntiAna | Client" SPC %client.name SPC "(" @ %client.bl_id @ ") OK!");
		parent::autoAdminCheck(%client); //continue on with the normal function
	}
};

function checkPrefUpdate() { //function for checking if the package is enabled
  if(!$Pref::AntiAna::Enabled) { //is the pref disabled?
		if($AntiAna::CheckEnabled) { //is the variable true?
      deactivatePackage(AntiAna); //if all checks have passed, deactivate the package
      $AntiAna::CheckEnabled = false; //make sure to set the variable to false so we don't trigger this again without first finding a change
    }
  }
	else if($Pref::AntiAna::Enabled) { //is the pref enabled?
    if(!$AntiAna::CheckEnabled) { //is the variable false?
      activatePackage(AntiAna); //if all checks have passed, activate the package
      $AntiAna::CheckEnabled = true; //make sure to set the variable to true so we don't trigger this again without first finding a change
    }
  }
  cancel($AntiAna::MyCheckSchedule); //cancel the schedule so we wait
  $AntiAna::CheckSchedule = schedule(5000, 0, checkPrefUpdate); //check every 5 seconds; todo: implement pref for user-specified time
}
$AntiAna::CheckEnabled = true; //when we run the script set this to true
activatePackage(AntiAna); //self explanatory
checkPrefUpdate(); //trigger this function so it can periodically run checks
